clear all
close all
n = 50;
t = linspace(0,2*pi,n+1);
t = t(1:n);
d = [sin(3*t);sin(4*t);sin(5*t)];
k = 3; % Bspline degree
level = 2; % number of steps of points refinement
% end of user defined parameters
n = size(d,2);
M = 1000;
t = linspace(k,n+k,M); 
s = zeros(3,M);
for j = 1:n+k-min(k-1,1)
  s = s+diag(d(:,mod(j-1,n)+1))*repmat(N(k,t-j),3,1);
end
vertices = d;
for l = 1:level
  m = size(vertices,2);
  vertices = reshape(repmat(vertices,2,1),3,2*m);
  for i = 1:k-1
    vertices = [vertices,vertices(:,1)];
    vertices = (vertices(:,1:end-1)+vertices(:,2:end))/2;
  end
end
plot3(d(1,:),d(2,:),d(3,:),'o',...
vertices(1,:),vertices(2,:),vertices(3,:),'*',...
s(1,:),s(2,:),s(3,:),'.')
legend('original points',sprintf('refined points (n = %d)',level),...
sprintf('curve (k = %d)',k))
